Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn_rdgrft.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn_rdgrft.F90	(revision 8564)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn_rdgrft.F90	(revision 8565)
@@ -61,6 +61,4 @@
    REAL(wp) ::   rn_pstar         ! determines ice strength, Hibler JPO79
    REAL(wp) ::   rn_crhg          ! determines changes in ice strength
-   LOGICAL  ::   ln_str_R75       ! ice strength parameterization (Rothrock75)
-   REAL(wp) ::   rn_perdg         ! ridging work divided by pot. energy change in ridging
    REAL(wp) ::   rn_csrdg         ! fraction of shearing energy contributing to ridging            
    LOGICAL  ::   ln_partf_lin     ! participation function linear (Thorndike et al. (1975))
@@ -130,12 +128,12 @@
       !!
       INTEGER  ::   ji, jj, jk, jl             ! dummy loop index
-      INTEGER  ::   niter, iterate_ridging     ! local integer 
-      INTEGER  ::   nidx2                      ! local integer
+      INTEGER  ::   iter, iterate_ridging      ! local integer 
+      INTEGER  ::   ipti                       ! local integer
       REAL(wp) ::   zfac                       ! local scalar
-      INTEGER , DIMENSION(jpij) ::   idxice2       ! compute ridge/raft or not
+      INTEGER , DIMENSION(jpij) ::   iptidx        ! compute ridge/raft or not
       REAL(wp), DIMENSION(jpij) ::   zdivu_adv     ! divu as implied by transport scheme  (1/s)
       REAL(wp), DIMENSION(jpij) ::   zdivu, zdelt  ! 1D divu_i & delta_i
       !
-      INTEGER, PARAMETER ::   nitermax = 20    
+      INTEGER, PARAMETER ::   jp_itermax = 20    
       !!-------------------------------------------------------------------
       ! controls
@@ -154,25 +152,25 @@
       ! 0) Identify grid cells with ice
       !--------------------------------
-      nidx = 0   ;   idxice(:) = 0
+      npti = 0   ;   nptidx(:) = 0
       DO jj = 1, jpj
          DO ji = 1, jpi
             IF ( SUM(a_i(ji,jj,:)) > 0._wp ) THEN
-               nidx           = nidx + 1
-               idxice( nidx ) = (jj - 1) * jpi + ji
+               npti           = npti + 1
+               nptidx( npti ) = (jj - 1) * jpi + ji
             ENDIF
          END DO
       END DO
 
-      IF( nidx > 0 ) THEN
+      IF( npti > 0 ) THEN
         
          ! just needed here
-         CALL tab_2d_1d( nidx, idxice(1:nidx), zdivu(1:nidx), divu_i(:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), zdelt(1:nidx), delta_i(:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), zdivu(1:npti), divu_i(:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), zdelt(1:npti), delta_i(:,:) )
          ! needed here and in the iteration loop
-         CALL tab_3d_2d( nidx, idxice(1:nidx), a_i_2d  (1:nidx,1:jpl), a_i(:,:,:) )
-         CALL tab_3d_2d( nidx, idxice(1:nidx), v_i_2d  (1:nidx,1:jpl), v_i(:,:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), ato_i_1d(1:nidx)      , ato_i(:,:) )
-
-         DO ji = 1, nidx
+         CALL tab_3d_2d( npti, nptidx(1:npti), a_i_2d  (1:npti,1:jpl), a_i(:,:,:) )
+         CALL tab_3d_2d( npti, nptidx(1:npti), v_i_2d  (1:npti,1:jpl), v_i(:,:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), ato_i_1d(1:npti)      , ato_i(:,:) )
+
+         DO ji = 1, npti
             !-----------------------------------------------------------------------------!
             ! 2) Dynamical inputs (closing rate, divu_adv, opning)
@@ -219,19 +217,19 @@
          !------------------------------------------------
          CALL rdgrft_prep( a_i_2d, v_i_2d, ato_i_1d )
-         nidx2 = 0 ; idxice2(:) = 0
-         DO ji = 1, nidx
+         ipti = 0 ; iptidx(:) = 0
+         DO ji = 1, npti
             IF( SUM( ABS(apartf(ji,1:jpl)) ) > 0._wp .AND. closing_gross(ji) > 0._wp ) THEN
-               nidx2 = nidx2 + 1
-               idxice2    (nidx2)   = idxice     (ji)
-               a_i_2d     (nidx2,:) = a_i_2d     (ji,:)  ! adjust to new indices
-               v_i_2d     (nidx2,:) = v_i_2d     (ji,:)  ! adjust to new indices
-               ato_i_1d   (nidx2)   = ato_i_1d   (ji)    ! adjust to new indices
-               closing_net(nidx2)   = closing_net(ji)    ! adjust to new indices
-               zdivu_adv  (nidx2)   = zdivu_adv  (ji)    ! adjust to new indices
-               opning     (nidx2)   = opning     (ji)    ! adjust to new indices
+               ipti = ipti + 1
+               iptidx     (ipti)   = nptidx     (ji)
+               a_i_2d     (ipti,:) = a_i_2d     (ji,:)  ! adjust to new indices
+               v_i_2d     (ipti,:) = v_i_2d     (ji,:)  ! adjust to new indices
+               ato_i_1d   (ipti)   = ato_i_1d   (ji)    ! adjust to new indices
+               closing_net(ipti)   = closing_net(ji)    ! adjust to new indices
+               zdivu_adv  (ipti)   = zdivu_adv  (ji)    ! adjust to new indices
+               opning     (ipti)   = opning     (ji)    ! adjust to new indices
             ENDIF
          END DO
-         idxice(:) = idxice2(:)
-         nidx      = nidx2
+         nptidx(:) = iptidx(:)
+         npti      = ipti
 
       ENDIF
@@ -240,5 +238,5 @@
       ! Start ridging
       !--------------
-      IF( nidx > 0 ) THEN
+      IF( npti > 0 ) THEN
          
          !-----------
@@ -246,32 +244,32 @@
          !-----------
          ! fields used but not modified
-         CALL tab_2d_1d( nidx, idxice(1:nidx), sss_1d(1:nidx), sss_m(:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), sst_1d(1:nidx), sst_m(:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), sss_1d(1:npti), sss_m(:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), sst_1d(1:npti), sst_m(:,:) )
          ! the following fields are modified in this routine
-         !!CALL tab_2d_1d( nidx, idxice(1:nidx), ato_i_1d(1:nidx), ato_i(:,:) )
-         !!CALL tab_3d_2d( nidx, idxice(1:nidx), a_i_2d(1:nidx,1:jpl), a_i(:,:,:) )
-         !!CALL tab_3d_2d( nidx, idxice(1:nidx), v_i_2d  (1:nidx,1:jpl), v_i  (:,:,:) )
-         CALL tab_3d_2d( nidx, idxice(1:nidx), v_s_2d (1:nidx,1:jpl), v_s (:,:,:) )
-         CALL tab_3d_2d( nidx, idxice(1:nidx), sv_i_2d(1:nidx,1:jpl), sv_i(:,:,:) )
-         CALL tab_3d_2d( nidx, idxice(1:nidx), oa_i_2d(1:nidx,1:jpl), oa_i(:,:,:) )
+         !!CALL tab_2d_1d( npti, nptidx(1:npti), ato_i_1d(1:npti), ato_i(:,:) )
+         !!CALL tab_3d_2d( npti, nptidx(1:npti), a_i_2d(1:npti,1:jpl), a_i(:,:,:) )
+         !!CALL tab_3d_2d( npti, nptidx(1:npti), v_i_2d  (1:npti,1:jpl), v_i  (:,:,:) )
+         CALL tab_3d_2d( npti, nptidx(1:npti), v_s_2d (1:npti,1:jpl), v_s (:,:,:) )
+         CALL tab_3d_2d( npti, nptidx(1:npti), sv_i_2d(1:npti,1:jpl), sv_i(:,:,:) )
+         CALL tab_3d_2d( npti, nptidx(1:npti), oa_i_2d(1:npti,1:jpl), oa_i(:,:,:) )
          IF ( nn_pnd_scheme > 0 ) THEN
-            CALL tab_3d_2d( nidx, idxice(1:nidx), a_ip_2d(1:nidx,1:jpl), a_ip(:,:,:) )
-            CALL tab_3d_2d( nidx, idxice(1:nidx), v_ip_2d(1:nidx,1:jpl), v_ip(:,:,:) )
+            CALL tab_3d_2d( npti, nptidx(1:npti), a_ip_2d(1:npti,1:jpl), a_ip(:,:,:) )
+            CALL tab_3d_2d( npti, nptidx(1:npti), v_ip_2d(1:npti,1:jpl), v_ip(:,:,:) )
          ENDIF
          DO jl = 1, jpl
             DO jk = 1, nlay_s
-               CALL tab_2d_1d( nidx, idxice(1:nidx), ze_s_2d(1:nidx,jk,jl), e_s(:,:,jk,jl) )
+               CALL tab_2d_1d( npti, nptidx(1:npti), ze_s_2d(1:npti,jk,jl), e_s(:,:,jk,jl) )
             END DO
             DO jk = 1, nlay_i
-               CALL tab_2d_1d( nidx, idxice(1:nidx), ze_i_2d(1:nidx,jk,jl), e_i(:,:,jk,jl) )
-            END DO
-         END DO
-         CALL tab_2d_1d( nidx, idxice(1:nidx), sfx_dyn_1d    (1:nidx), sfx_dyn    (:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), sfx_bri_1d    (1:nidx), sfx_bri    (:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), wfx_dyn_1d    (1:nidx), wfx_dyn    (:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), hfx_dyn_1d    (1:nidx), hfx_dyn    (:,:) )
-         CALL tab_2d_1d( nidx, idxice(1:nidx), wfx_snw_dyn_1d(1:nidx), wfx_snw_dyn(:,:) )
+               CALL tab_2d_1d( npti, nptidx(1:npti), ze_i_2d(1:npti,jk,jl), e_i(:,:,jk,jl) )
+            END DO
+         END DO
+         CALL tab_2d_1d( npti, nptidx(1:npti), sfx_dyn_1d    (1:npti), sfx_dyn    (:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), sfx_bri_1d    (1:npti), sfx_bri    (:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), wfx_dyn_1d    (1:npti), wfx_dyn    (:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), hfx_dyn_1d    (1:npti), hfx_dyn    (:,:) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), wfx_snw_dyn_1d(1:npti), wfx_snw_dyn(:,:) )
          IF ( nn_pnd_scheme > 0 ) THEN
-            CALL tab_2d_1d( nidx, idxice(1:nidx), wfx_pnd_1d(1:nidx), wfx_pnd(:,:) )
+            CALL tab_2d_1d( npti, nptidx(1:npti), wfx_pnd_1d(1:npti), wfx_pnd(:,:) )
          ENDIF
          
@@ -279,7 +277,7 @@
          ! 3) Ridging iteration
          !-----------------------------------------------------------------------------!
-         niter           = 1
+         iter            = 1
          iterate_ridging = 1      
-         DO WHILE( iterate_ridging > 0 .AND. niter < nitermax )
+         DO WHILE( iterate_ridging > 0 .AND. iter < jp_itermax )
 
             CALL rdgrft_prep( a_i_2d, v_i_2d, ato_i_1d )
@@ -294,5 +292,5 @@
             ! rates were reduced above), ridge again with new rates.
             iterate_ridging = 0
-            DO ji = 1, nidx
+            DO ji = 1, npti
                zfac = 1._wp - ( ato_i_1d(ji) + SUM( a_i_2d(ji,:) ) )
                IF( ABS( zfac ) < epsi10 ) THEN
@@ -308,6 +306,6 @@
             END DO
             !
-            niter = niter + 1
-            IF( niter  >  nitermax )    CALL ctl_warn( 'icedyn_rdgrft: non-converging ridging scheme' )
+            iter = iter + 1
+            IF( iter  >  jp_itermax )    CALL ctl_warn( 'icedyn_rdgrft: non-converging ridging scheme' )
             !
          END DO
@@ -316,32 +314,32 @@
          ! 1D <==> 2D
          !-----------
-         CALL tab_1d_2d( nidx, idxice(1:nidx), ato_i_1d(1:nidx), ato_i(:,:) )
-         CALL tab_2d_3d( nidx, idxice(1:nidx), a_i_2d (1:nidx,1:jpl), a_i (:,:,:) )
-         CALL tab_2d_3d( nidx, idxice(1:nidx), v_i_2d (1:nidx,1:jpl), v_i (:,:,:) )
-         CALL tab_2d_3d( nidx, idxice(1:nidx), v_s_2d (1:nidx,1:jpl), v_s (:,:,:) )
-         CALL tab_2d_3d( nidx, idxice(1:nidx), sv_i_2d(1:nidx,1:jpl), sv_i(:,:,:) )
-         CALL tab_2d_3d( nidx, idxice(1:nidx), oa_i_2d(1:nidx,1:jpl), oa_i(:,:,:) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), ato_i_1d(1:npti), ato_i(:,:) )
+         CALL tab_2d_3d( npti, nptidx(1:npti), a_i_2d (1:npti,1:jpl), a_i (:,:,:) )
+         CALL tab_2d_3d( npti, nptidx(1:npti), v_i_2d (1:npti,1:jpl), v_i (:,:,:) )
+         CALL tab_2d_3d( npti, nptidx(1:npti), v_s_2d (1:npti,1:jpl), v_s (:,:,:) )
+         CALL tab_2d_3d( npti, nptidx(1:npti), sv_i_2d(1:npti,1:jpl), sv_i(:,:,:) )
+         CALL tab_2d_3d( npti, nptidx(1:npti), oa_i_2d(1:npti,1:jpl), oa_i(:,:,:) )
          IF ( nn_pnd_scheme > 0 ) THEN
-            CALL tab_2d_3d( nidx, idxice(1:nidx), a_ip_2d(1:nidx,1:jpl), a_ip(:,:,:) )
-            CALL tab_2d_3d( nidx, idxice(1:nidx), v_ip_2d(1:nidx,1:jpl), v_ip(:,:,:) )
+            CALL tab_2d_3d( npti, nptidx(1:npti), a_ip_2d(1:npti,1:jpl), a_ip(:,:,:) )
+            CALL tab_2d_3d( npti, nptidx(1:npti), v_ip_2d(1:npti,1:jpl), v_ip(:,:,:) )
          ENDIF
          DO jl = 1, jpl
             DO jk = 1, nlay_s
-               CALL tab_1d_2d( nidx, idxice(1:nidx), ze_s_2d(1:nidx,jk,jl), e_s(:,:,jk,jl) )
+               CALL tab_1d_2d( npti, nptidx(1:npti), ze_s_2d(1:npti,jk,jl), e_s(:,:,jk,jl) )
             END DO
             DO jk = 1, nlay_i
-               CALL tab_1d_2d( nidx, idxice(1:nidx), ze_i_2d(1:nidx,jk,jl), e_i(:,:,jk,jl) )
-            END DO
-         END DO
-         CALL tab_1d_2d( nidx, idxice(1:nidx), sfx_dyn_1d    (1:nidx), sfx_dyn    (:,:) )
-         CALL tab_1d_2d( nidx, idxice(1:nidx), sfx_bri_1d    (1:nidx), sfx_bri    (:,:) )
-         CALL tab_1d_2d( nidx, idxice(1:nidx), wfx_dyn_1d    (1:nidx), wfx_dyn    (:,:) )
-         CALL tab_1d_2d( nidx, idxice(1:nidx), hfx_dyn_1d    (1:nidx), hfx_dyn    (:,:) )
-         CALL tab_1d_2d( nidx, idxice(1:nidx), wfx_snw_dyn_1d(1:nidx), wfx_snw_dyn(:,:) )
+               CALL tab_1d_2d( npti, nptidx(1:npti), ze_i_2d(1:npti,jk,jl), e_i(:,:,jk,jl) )
+            END DO
+         END DO
+         CALL tab_1d_2d( npti, nptidx(1:npti), sfx_dyn_1d    (1:npti), sfx_dyn    (:,:) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), sfx_bri_1d    (1:npti), sfx_bri    (:,:) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), wfx_dyn_1d    (1:npti), wfx_dyn    (:,:) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), hfx_dyn_1d    (1:npti), hfx_dyn    (:,:) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), wfx_snw_dyn_1d(1:npti), wfx_snw_dyn(:,:) )
          IF ( nn_pnd_scheme > 0 ) THEN
-            CALL tab_1d_2d( nidx, idxice(1:nidx), wfx_pnd_1d(1:nidx), wfx_pnd(:,:) )
+            CALL tab_1d_2d( npti, nptidx(1:npti), wfx_pnd_1d(1:npti), wfx_pnd(:,:) )
          ENDIF
 
-      ENDIF ! nidx > 0
+      ENDIF ! npti > 0
    
       CALL ice_var_agg( 1 ) 
@@ -378,6 +376,6 @@
 
       !                       ! Ice thickness needed for rafting
-      WHERE( pa_i(1:nidx,:) > 0._wp )   ;   zhi(1:nidx,:) = pv_i(1:nidx,:) / pa_i(1:nidx,:)
-      ELSEWHERE                         ;   zhi(1:nidx,:) = 0._wp
+      WHERE( pa_i(1:npti,:) > 0._wp )   ;   zhi(1:npti,:) = pv_i(1:npti,:) / pa_i(1:npti,:)
+      ELSEWHERE                         ;   zhi(1:npti,:) = 0._wp
       END WHERE
 
@@ -398,8 +396,8 @@
       ! Compute total area of ice plus open water.
       ! This is in general not equal to one because of divergence during transport
-      zasum(1:nidx) = pato_i(1:nidx) + SUM( pa_i(1:nidx,:), dim=2 )
-      !
-      WHERE( zasum(1:nidx) > 0._wp )   ;   z1_asum(1:nidx) = 1._wp / zasum(1:nidx)
-      ELSEWHERE                        ;   z1_asum(1:nidx) = 0._wp
+      zasum(1:npti) = pato_i(1:npti) + SUM( pa_i(1:npti,:), dim=2 )
+      !
+      WHERE( zasum(1:npti) > 0._wp )   ;   z1_asum(1:npti) = 1._wp / zasum(1:npti)
+      ELSEWHERE                        ;   z1_asum(1:npti) = 0._wp
       END WHERE
       ! Compute cumulative thickness distribution function
@@ -407,13 +405,13 @@
       ! where zGsum(n) is the fractional area in categories 0 to n.
       ! initial value (in h = 0) equals open water area
-      zGsum(1:nidx,-1) = 0._wp
-      zGsum(1:nidx,0 ) = pato_i(1:nidx) * z1_asum(1:nidx)
+      zGsum(1:npti,-1) = 0._wp
+      zGsum(1:npti,0 ) = pato_i(1:npti) * z1_asum(1:npti)
       DO jl = 1, jpl
-         zGsum(1:nidx,jl) = ( pato_i(1:nidx) + SUM( pa_i(1:nidx,1:jl), dim=2 ) ) * z1_asum(1:nidx)  ! sum(1:jl) is ok (and not jpl)
+         zGsum(1:npti,jl) = ( pato_i(1:npti) + SUM( pa_i(1:npti,1:jl), dim=2 ) ) * z1_asum(1:npti)  ! sum(1:jl) is ok (and not jpl)
       END DO
       !
       IF( ln_partf_lin ) THEN          !--- Linear formulation (Thorndike et al., 1975)
          DO jl = 0, jpl    
-            DO ji = 1, nidx
+            DO ji = 1, npti
                IF    ( zGsum(ji,jl)   < rn_gstar ) THEN
                   apartf(ji,jl) = z1_gstar * ( zGsum(ji,jl) - zGsum(ji,jl-1) ) * &
@@ -432,10 +430,10 @@
          zfac = 1._wp / ( 1._wp - EXP(-z1_astar) )
          DO jl = -1, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                zGsum(ji,jl) = EXP( -zGsum(ji,jl) * z1_astar ) * zfac
             END DO
          END DO
          DO jl = 0, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                apartf(ji,jl) = zGsum(ji,jl-1) - zGsum(ji,jl)
             END DO
@@ -447,5 +445,5 @@
       IF( ln_rafting .AND. ln_ridging ) THEN             !- ridging & rafting
          DO jl = 1, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                aridge(ji,jl) = ( 1._wp + TANH ( rn_craft * ( zhi(ji,jl) - rn_hraft ) ) ) * 0.5_wp * apartf(ji,jl)
                araft (ji,jl) = apartf(ji,jl) - aridge(ji,jl)
@@ -454,5 +452,5 @@
       ELSEIF( ln_ridging .AND. .NOT. ln_rafting ) THEN   !- ridging alone
          DO jl = 1, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                aridge(ji,jl) = apartf(ji,jl)
                araft (ji,jl) = 0._wp
@@ -461,5 +459,5 @@
       ELSEIF( ln_rafting .AND. .NOT. ln_ridging ) THEN   !- rafting alone   
          DO jl = 1, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                aridge(ji,jl) = 0._wp
                araft (ji,jl) = apartf(ji,jl)
@@ -468,5 +466,5 @@
       ELSE                                               !- no ridging & no rafting
          DO jl = 1, jpl
-            DO ji = 1, nidx
+            DO ji = 1, npti
                aridge(ji,jl) = 0._wp
                araft (ji,jl) = 0._wp         
@@ -502,8 +500,8 @@
 
       zfac = 1._wp / hi_hrft
-      zaksum(1:nidx) = apartf(1:nidx,0)
+      zaksum(1:npti) = apartf(1:npti,0)
       ! Transfer function
       DO jl = 1, jpl !all categories have a specific transfer function
-         DO ji = 1, nidx
+         DO ji = 1, npti
             IF ( apartf(ji,jl) > 0._wp ) THEN
                zhmean         = MAX( SQRT( rn_hstar * zhi(ji,jl) ), zhi(ji,jl) * hrdg_hi_min )
@@ -530,9 +528,9 @@
       !  closing rate to a gross closing rate.  
       ! NOTE: 0 < aksum <= 1
-      WHERE( zaksum(1:nidx) > 0._wp )   ;   closing_gross(1:nidx) = closing_net(1:nidx) / zaksum(1:nidx)
-      ELSEWHERE                         ;   closing_gross(1:nidx) = 0._wp
+      WHERE( zaksum(1:npti) > 0._wp )   ;   closing_gross(1:npti) = closing_net(1:npti) / zaksum(1:npti)
+      ELSEWHERE                         ;   closing_gross(1:npti) = 0._wp
       END WHERE
       
-      DO ji = 1, nidx  
+      DO ji = 1, npti  
          ! correction to closing rate and opening if closing rate is excessive
          !---------------------------------------------------------------------
@@ -552,5 +550,5 @@
       ! would be removed.  Reduce the opening rate proportionately.
       DO jl = 1, jpl
-         DO ji = 1, nidx
+         DO ji = 1, npti
             zfac = apartf(ji,jl) * closing_gross(ji) * rdt_ice
 !!            IF( zfac > pa_i(ji,jl) .AND. zfac > 0._wp ) THEN
@@ -594,5 +592,5 @@
       ! 1) Compute change in open water area due to closing and opening.
       !-------------------------------------------------------------------------------
-      DO ji = 1, nidx
+      DO ji = 1, npti
          ato_i_1d(ji) = MAX( 0._wp, ato_i_1d(ji) + ( opning(ji) - apartf(ji,0) * closing_gross(ji) ) * rdt_ice )
       END DO
@@ -603,7 +601,7 @@
       DO jl1 = 1, jpl
 
-         CALL tab_2d_1d( nidx, idxice(1:nidx), s_i_1d(1:nidx), s_i(:,:,jl1) )
-
-         DO ji = 1, nidx
+         CALL tab_2d_1d( npti, nptidx(1:npti), s_i_1d(1:npti), s_i(:,:,jl1) )
+
+         DO ji = 1, npti
 
             !------------------------------------------------
@@ -716,5 +714,5 @@
          ! special loop for e_i because of layers jk
          DO jk = 1, nlay_i
-            DO ji = 1, nidx
+            DO ji = 1, npti
                IF( apartf(ji,jl1) > 0._wp .AND. closing_gross(ji) > 0._wp ) THEN
                   ! Compute ridging /rafting fractions
@@ -736,5 +734,5 @@
          DO jl2  = 1, jpl 
             !
-            DO ji = 1, nidx
+            DO ji = 1, npti
 
                IF( apartf(ji,jl1) > 0._wp .AND. closing_gross(ji) > 0._wp ) THEN
@@ -783,5 +781,5 @@
 
             DO jk = 1, nlay_i
-               DO ji = 1, nidx
+               DO ji = 1, npti
                   IF( apartf(ji,jl1) > 0._wp .AND. closing_gross(ji) > 0._wp )   &
                      &   ze_i_2d(ji,jk,jl2) = ze_i_2d(ji,jk,jl2) + eirdg(ji,jk) * fvol(ji) + eirft(ji,jk) * zswitch(ji)                  
@@ -794,6 +792,6 @@
       !
       ! In case ridging/rafting lead to very small negative values (sometimes it happens)
-      WHERE( a_i_2d(1:nidx,:) < 0._wp )   a_i_2d(1:nidx,:) = 0._wp
-      WHERE( v_i_2d(1:nidx,:) < 0._wp )   v_i_2d(1:nidx,:) = 0._wp
+      WHERE( a_i_2d(1:npti,:) < 0._wp )   a_i_2d(1:npti,:) = 0._wp
+      WHERE( v_i_2d(1:npti,:) < 0._wp )   v_i_2d(1:npti,:) = 0._wp
       !
    END SUBROUTINE rdgrft_shift
@@ -820,13 +818,13 @@
       !!----------------------------------------------------------------------
       !                              !--------------------------------------------------!
-      IF( ln_str_R75 ) THEN          ! Ice strength => Rothrock (1975) method           !
-      !                              !--------------------------------------------------!
-      !                              !--------------------------------------------------!
-      ELSEIF( ln_str_H79 ) THEN      ! Ice strength => Hibler (1979) method             !
+      IF( ln_str_H79 ) THEN          ! Ice strength => Hibler (1979) method             !
       !                              !--------------------------------------------------!
          strength(:,:) = rn_pstar * SUM( v_i(:,:,:), dim=3 ) * EXP( -rn_crhg * ( 1._wp - SUM( a_i(:,:,:), dim=3 ) ) )
-         !
          ismooth = 1
-         !
+         !                           !--------------------------------------------------!
+      ELSE                           ! Zero strength                                    !
+         !                           !--------------------------------------------------!
+         strength(:,:) = 0._wp
+         ismooth = 0
       ENDIF
       !                              !--------------------------------------------------!
@@ -896,5 +894,4 @@
       !!
       NAMELIST/namdyn_rdgrft/ ln_str_H79, rn_pstar, rn_crhg, &
-         &                    ln_str_R75, rn_perdg,          &
          &                    rn_csrdg  ,                    &
          &                    ln_partf_lin, rn_gstar,        &
@@ -921,6 +918,4 @@
          WRITE(numout,*) '            1st bulk-rheology parameter                        rn_pstar     = ', rn_pstar
          WRITE(numout,*) '            2nd bulk-rhelogy parameter                         rn_crhg      = ', rn_crhg
-         WRITE(numout,*) '      ice strength parameterization Rothrock (1975)            ln_str_R75   = ', ln_str_R75 
-         WRITE(numout,*) '            Ratio of ridging work to PotEner change in ridging rn_perdg     = ', rn_perdg 
          WRITE(numout,*) '      Fraction of shear energy contributing to ridging         rn_csrdg     = ', rn_csrdg 
          WRITE(numout,*) '      linear ridging participation function                    ln_partf_lin = ', ln_partf_lin
@@ -940,8 +935,4 @@
       ENDIF
       !
-      IF ( ( ln_str_H79 .AND. ln_str_R75 ) .OR. ( .NOT.ln_str_H79 .AND. .NOT.ln_str_R75 ) ) THEN
-         CALL ctl_stop( 'ice_dyn_rdgrft_init: choose one and only one formulation for ice strength (ln_str_H79 or ln_str_R75)' )
-      ENDIF
-      !
       IF ( ( ln_partf_lin .AND. ln_partf_exp ) .OR. ( .NOT.ln_partf_lin .AND. .NOT.ln_partf_exp ) ) THEN
          CALL ctl_stop( 'ice_dyn_rdgrft_init: choose one and only one participation function (ln_partf_lin or ln_partf_exp)' )
